#include "Sudoku.h"

#include <iostream>
#include <fstream>

void Sudoku::Zaladuj(int noweLiczby[], int rozmiar)
{
    for (int i = 0; i < 9; i++) // Wiersz
    {
        for (int j = 0; j < 9; j++) // Kolumna
        {
            liczby[i][j] = noweLiczby[i * 9 + j];
        }
    }
}

bool Sudoku::ZaladujZPliku(std::string nazwa)
{
    std::fstream plik(nazwa);

    int wiersz = 0, kolumna = 0;
    if (plik.good())
    {
        char c;
        while (plik.get(c))
        {
            if (c >= '0' && c <= '9')
            {
                int liczba = int(c - '0');

                liczby[wiersz][kolumna] = liczba;

                kolumna++;

                if (kolumna > 8)
                {
                    kolumna = 0;
                    wiersz++;
                }
            }
        }

        const int zaladowano = wiersz * 9 + kolumna;

        if (zaladowano != 81)
        {
            std::cout << "Zaladowano niepoprawna ilosc(" << zaladowano << ")\n";
            return false;
        }
    }
    else
    {
        std::cout << "NIE UDALO SIE OTWORZYC PLIKU!\n";

        plik.close();
        return false;
    }

    plik.close();

    return true;
}

void Sudoku::Wypisz()
{
    for (int i = 0; i < 9; i++)
    {
        for (int j = 0; j < 9; j++)
        {
            std::cout << liczby[i][j];

            if (j == 2 || j == 5) std::cout << '|';
        }

        std::cout << '\n';

        if (i == 2 || i == 5)
        {
            std::cout << "-----------\n";
        }
    }
}

bool Sudoku::Rozwiaz(int wiersz, int kolumna)
{
    if (wiersz == (9 - 1) && kolumna == 9)
        return true;

    if (kolumna == 9)
    {
        wiersz++;
        kolumna = 0;
    }

    if (liczby[wiersz][kolumna] > 0)
        return Rozwiaz(wiersz, kolumna + 1);

    for (int num = 1; num <= 9; num++)
    {
        if (SprawdzLiczbe(wiersz, kolumna, num))
        {
            liczby[wiersz][kolumna] = num;

            if (Rozwiaz(wiersz, kolumna + 1))
                return true;
        }

        liczby[wiersz][kolumna] = 0;
    }
    return false;
}

bool Sudoku::SprawdzLiczbe(int wiersz, int kolumna, int liczba)
{
    // Sprawdzamy wiersze
    for (int x = 0; x <= 8; x++)
        if (liczby[wiersz][x] == liczba)
            return false;

    // Sprawdzamy kolumny
    for (int x = 0; x <= 8; x++)
        if (liczby[x][kolumna] == liczba)
            return false;

    // Sprawdzamy kwadrat
    for (int i = 0; i < 3; i++)
        for (int j = 0; j < 3; j++)
            if (liczby[i + (wiersz - wiersz % 3)][j + (kolumna - kolumna % 3)] == liczba)
                return false;

    return true;
}
